$!++
$! BLDRUN.COM -- 11-JAN-2000 Uwe Zessin
$! 24-APR-2000 ZE. -- add "component" support
$! 27-APR-2000 ZE. -- add data structure support for POSIX
$!
$! run compilation
$!	P1 = OLB name (VMS, PARSER) *
$!	     "$ALL"   = compile all modules of all OLBs
$!	     "C:name" = compile all modules belonging to component "name"
$!	     "C:*"    = list all component names in CONFIG_MODULES.DAT
$!	P2 = module name (VMS_SYS) *
$!
$!--
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$! -----
$ if F$TRNLNM("PYTHON_CFG_DEBUG") .eqs. ""
$ then
$   write SYS$ERROR "%BLDRUN-W-NOSETUP, SETUP.COM not run - doing now"
$   @ PYTHON_VMS:SETUP
$ endif
$! -----
$ T_FILNAM_CFGMOD = "PYTHON_VMS:CONFIG_MODULES.DAT"
$ T_FILNAM_CFGOLB = "PYTHON_VMS:CONFIG_OLB.DAT"
$ T_FILNAM_VMSVER = "PYTHON_VMS:VMSDAT_VMSVER.DAT"
$!
$ L_CC_VERSION = 1000 ! parameter handling
$!
$ RMS$_FLK        = %X0001828A
$ RMS$_RLK        = %X000182AA
$ RMS$_RNF        = %X000182B2
$ SS$_ABORT       = %X2C
$ STS$M_INHIB_MSG = %X10000000
$! -----
$ CFGMOD_K_OLBNAM    = 0
$ CFGMOD_K_MODULE    = 1
$ CFGMOD_K_COMPONENT = 2
$ CFGMOD_K_OLB       = 3
$ CFGMOD_K_DBG       = 4
$ CFGMOD_K_THREAD    = 5
$ CFGMOD_K_ENVCOMP   = 6
$!@@
$ CFGMOD_K_VER_AD    = 7
$ CFGMOD_K_VER_AP    = 8
$ CFGMOD_K_VER_A     = 7
$ CFGMOD_K_VER_VD    = 9
$ CFGMOD_K_VER_VP    = 10
$ CFGMOD_K_VER_V     = 9
$ CFGMOD_K_PROC      = 11
$ CFGMOD_K_INCL      = 12
$!
$ CFGMOD_K_IDX_OLBNAM    = 0
$ CFGMOD_K_IDX_MODULE    = 1
$ CFGMOD_K_IDX_COMPONENT = 2
$! -----
$ CFGOLB_K_IDX_OLBNAM = 0
$!
$ CFGOLB_K_OLBNAME  = 0
$ CFGOLB_K_MODCOUNT = 1
$ CFGOLB_K_SIZALPD  = 2
$ CFGOLB_K_SIZALPN  = 3
$ CFGOLB_K_SIZVAXD  = 4
$ CFGOLB_K_SIZVAXN  = 5
$! -----
$ VMSVER_K_IDX_VER_NAM = 0
$ VMSVER_K_IDX_VMSVER  = 1 ! non-unique !
$! ----------------------------------------------------------------------------
$!+
$! get current VMS version information
$!-
$!! T_SYI_VMSVER = "INVALID"
$ T_SYI_VMSVER = "V7.1"
$ T_SYI_VMSVER = "V5.5-2"
$!
$ T_SYI_VMSVER = F$GETSYI("VERSION")
$!
$	V = F$VERIFY(0)
$ call FIND_VMSVER "''T_SYI_VMSVER'"
$	V = F$VERIFY(V)
$ BLDRUN_W_VMSVER = BLDRUN_GW_VMSVER
$ delete /SYMBOL /GLOBAL BLDRUN_GW_VMSVER
$!
$ if (BLDRUN_W_VMSVER .eqs "0")
$ then
$   write SYS$ERROR "%BLDRUN-F-NOVERINFO, version information missing from file"
$   write SYS$ERROR " \",T_SYI_VMSVER,"\"
$   write SYS$ERROR " (please see documentation on how to update file VMSDAT_VMSVER.TXT)"
$   set DEFAULT '_DEFAULT'
$   exit (SS$_ABORT .and. (.not. STS$M_INHIB_MSG))
$ endif
$! ----------------------------------------------------------------------------
$ close /noLOG FIL_CFGMOD
$ open /read /share=write FIL_CFGMOD 'T_FILNAM_CFGMOD' /error= ERR_CFGMODOPN
$ goto CFGMOD_IS_OPEN
$! --------------------
$ERR_CFGMODOPN:
$   _STATUS = $STATUS
$   write SYS$ERROR "%BLDRUN-F-OPENCFG, error opening configuration file"
$   write SYS$ERROR " \",T_FILNAM_CFGMOD,"\"
$   set DEFAULT '_DEFAULT'
$   exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$! --------------------
$CFGMOD_IS_OPEN:
$! ----------------------------------------------------------------------------
$ T_OLBNAM = F$EDIT(P1,"COLLAPSE,UPCASE")
$! --------------------
$ if (T_OLBNAM .eqs. "")
$ then
$   write SYS$ERROR "%BLDRUN-F-BADPARAM, parameter P1 must specify .OLB name"
$   close /noLOG FIL_CFGMOD
$   set DEFAULT '_DEFAULT'
$   exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$ endif
$ if (T_OLBNAM .eqs. "$ALL")
$ then
$   call COMPILE_ALL
$   exit 1
$ endif
$! ----------------------------------------
$ if (F$EXTRACT(0,2,P1) .eqs. "C:") .or. -
     (F$EXTRACT(0,2,P1) .eqs. "C=")
$ then
$   T_COMPONENT = F$EXTRACT(2,9999,P1)
$   if (T_COMPONENT .eqs. "*")
$   then
$     write SYS$ERROR "%BLDRUN-F-COMPNOWLD, wildcard component not supported"
$     call LIST_COMPONENTS ! instead
$     delete /SYMBOL /GLOBAL BLDRUN_GL_MODULE_COUNT
$     close /noLOG FIL_CFGMOD
$     set DEFAULT '_DEFAULT'
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$   endif
$   !
$	V = F$VERIFY(0)
$   call COUNT_COMPONENT_MODULES "''T_COMPONENT'"
$	V = F$VERIFY(V)
$   L_MODULE_COUNT = BLDRUN_GL_MODULE_COUNT
$   delete /SYMBOL /GLOBAL BLDRUN_GL_MODULE_COUNT
$   if (L_MODULE_COUNT .eq. 0)
$   then
$     write SYS$ERROR "%BLDRUN-W-NOMODULE, no modules in component: ", T_COMPONENT
$     close /noLOG FIL_CFGMOD
$     set DEFAULT '_DEFAULT'
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$   else
$     write SYS$ERROR -
	"%BLDRUN-I-MODCNT, found ''L_MODULE_COUNT' modules in component: ", -
	T_COMPONENT
$   endif
$!@@@@@
$   ! ----------------------------------------
$   ! -- compile all modules in a component
$   ! --------------------
$   L_COMPMOD_COUNTER = 0
$   T_KEY = F$FAO("!39AS",T_COMPONENT)
$   read /key= &T_KEY /index= 'CFGMOD_K_IDX_COMPONENT' /end= EOF_COMPCMP -
	/error= ERR_COMPCMP -
	FIL_CFGMOD  T_RECORD
$   L_COMPMOD_COUNTER = L_COMPMOD_COUNTER + 1		! first record matches
$   T_RECORD = F$EDIT(T_RECORD,"COLLAPSE")
$   call COMPILE_MODULE "''T_RECORD'" "NOVERABORT" "OLBCRE" -
	 "''F$FAO(" (!3UL/!3UL)",L_COMPMOD_COUNTER,L_MODULE_COUNT)'"
$   !
$   ! -- turn to sequential read
$LOOP_COMPCMP_MODULES:
$    read /end= EOF_COMPCMP  FIL_CFGMOD  T_RECORD
$    T_RECORD  = F$EDIT(T_RECORD,"COLLAPSE")
$    T_OLBNAM  = F$ELEMENT (CFGMOD_K_OLBNAM,"|",T_RECORD)
$    T_COMPNAM = F$ELEMENT (CFGMOD_K_COMPONENT,"|",T_RECORD)
$    !!show symbol t_*
$    if (F$FAO("!39AS",T_COMPNAM) .eqs. T_KEY)
$    then
$      L_COMPMOD_COUNTER = L_COMPMOD_COUNTER + 1		! record matches
$      on WARNING then $ continue
$      call COMPILE_MODULE "''T_RECORD'" "NOVERABORT" "OLBCRE" -
	    "''F$FAO(" (!3UL/!3UL)",L_COMPMOD_COUNTER,L_MODULE_COUNT)'"
$      goto LOOP_COMPCMP_MODULES			! try next record
$    endif
$    goto EOF_COMPCMP				! else: done
$    ! ----------------------------------------
$ERR_COMPCMP:
$    _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$    !! show symbol _STATUS
$    if (_STATUS .eqs. RMS$_RNF)
$    then	! %RMS-E-RNF, record not found
$      goto EOF_COMPCMP		! no module - normal exit
$    endif
$    if (_STATUS .eqs. RMS$_FLK)
$    then	! %RMS-E-FLK, file currently locked by another user
$      wait 00:00:00.05
$      goto LOOP_COMPCMP_MODULES	! retry
$    endif
$    if (_STATUS .eqs. RMS$_RLK)
$    then	! %RMS-E-RLK, target record currently locked by another stream
$      wait 00:00:00.05
$      goto LOOP_COMPCMP_MODULES	! retry
$    endif
$    ! -- some other error - try to unlock current record
$    read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_OLBNAM' /end= EOF_COMPCMP -
	/error= ERR_COMPCMP_IGNORE  FIL_CFGMOD  T_RECORD
$ERR_COMPCMP_IGNORE:
$    set DEFAULT '_DEFAULT'
$    exit _STATUS			! signal error
$! ----------------------------------------
$EOF_COMPCMP:
$   !! show symbol L_COMPMOD_COUNTER
$   BLDRUN_GL_COMPMOD_COUNTER == L_COMPMOD_COUNTER
$   ! ----------------------------------------
$   !@@@@@
$   close /noLOG FIL_CFGMOD
$   write SYS$ERROR "%BLDRUN-I-DONE, completed: ", P1
$   set DEFAULT '_DEFAULT'
$   exit 1
$!
$ endif
$! ----------------------------------------
$ T_MODULE = F$EDIT(P2,"COLLAPSE,UPCASE")
$ if (T_MODULE .eqs. "")
$ then
$   write SYS$ERROR "%BLDRUN-F-BADPARAM, parameter P2 must specify module name"
$   close /noLOG FIL_CFGMOD
$   set DEFAULT '_DEFAULT'
$   exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$ endif
$! --------------------
$ T_MODULE = F$PARSE(T_MODULE,,,"NAME")	! allow full filespec (cut&paste)
$! ----------------------------------------------------------------------------
$!+
$! count modules in OLB
$!-
$ if (T_OLBNAM .eqs. "*")
$ then
$   write SYS$ERROR "%BLDRUN-E-NOOLBWLD, cannot handle OLB wildcards"
$   ! @@@ call LIST_OLB ?
$   close /noLOG FIL_CFGMOD
$   set DEFAULT '_DEFAULT'
$   exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$ else
$	V = F$VERIFY(0)
$   call COUNT_OLBNAM_MODULES "''T_OLBNAM'"
$	V = F$VERIFY(V)
$   L_MODULE_COUNT = BLDRUN_GL_MODULE_COUNT
$   delete /SYMBOL /GLOBAL BLDRUN_GL_MODULE_COUNT
$   if (L_MODULE_COUNT .eq. 0)
$   then
$     write SYS$ERROR "%BLDRUN-W-NOMODULE, no modules in OLB: ", T_OLBNAM
$     close /noLOG FIL_CFGMOD
$   set DEFAULT '_DEFAULT'
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$   endif
$   if (T_MODULE .eqs. "*")
$   then
$     write SYS$ERROR "%BLDRUN-I-MODCNT, found ", L_MODULE_COUNT, " modules in OLB: ", T_OLBNAM
$   endif
$ endif
$! ----------------------------------------------------------------------------
$ if (T_MODULE .nes. "*")
$ then
$   ! -- compile a specific module
$   ! --------------------
$   ! - find it
$   T_KEY = F$FAO("!39AS",T_MODULE)
$   read /key= &T_KEY /index= 'CFGMOD_K_IDX_MODULE' /end= EOF_MODULE -
	/error= ERR_MODULE -
	FIL_CFGMOD  T_RECORD
$   !
$   T_RECORD = F$EDIT(T_RECORD,"COLLAPSE")
$   T_OLBNAM_REC = F$ELEMENT (CFGMOD_K_OLBNAM,"|",T_RECORD)
$   if (T_OLBNAM_REC .eqs. T_OLBNAM)
$   then
$     call COMPILE_MODULE "''T_RECORD'" "VERABORT" "NONEWOLB" ""
$   else
$     write SYS$ERROR -
	F$FAO("%BLDRUN-F-MODNOTOLB, module: !AS is in OLB: !AS, not: !AS", -
	       T_MODULE, T_OLBNAM_REC, T_OLBNAM)
$     close /noLOG FIL_CFGMOD
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$   endif
$   ! -----
$ else
$   ! -- compile all modules in an OLB
$   ! --------------------
$   L_COMPMOD_COUNTER = 0
$   T_KEY = F$FAO("!39AS",P1)
$   read /key= &T_KEY /index= 'CFGMOD_K_IDX_OLBNAM' /end= EOF_COMPMOD -
	/error= ERR_COMPMOD -
	FIL_CFGMOD  T_RECORD
$   L_COMPMOD_COUNTER = L_COMPMOD_COUNTER + 1		! first record matches
$   T_RECORD = F$EDIT(T_RECORD,"COLLAPSE")
$   call COMPILE_MODULE "''T_RECORD'" "NOVERABORT" "NEWOLB" -
	 "''F$FAO(" (!3UL/!3UL)",L_COMPMOD_COUNTER,L_MODULE_COUNT)'"
$   !
$   ! -- turn to sequential read
$LOOP_COMPMOD_MODULES:
$    read /end= EOF_COMPMOD  FIL_CFGMOD  T_RECORD
$    T_RECORD = F$EDIT(T_RECORD,"COLLAPSE")
$    T_OLBNAM = F$ELEMENT (CFGMOD_K_OLBNAM,"|",T_RECORD)
$    !! T_OLBNAM = F$EDIT(T_OLBNAM ,"COLLAPSE,UPCASE")
$    !!show symbol t_*
$    if (F$FAO("!39AS",T_OLBNAM) .eqs. T_KEY)
$    then
$      L_COMPMOD_COUNTER = L_COMPMOD_COUNTER + 1		! record matches
$      on WARNING then $ continue
$      call COMPILE_MODULE "''T_RECORD'" "NOVERABORT" "NONEWOLB" -
	    "''F$FAO(" (!3UL/!3UL)",L_COMPMOD_COUNTER,L_MODULE_COUNT)'"
$      goto LOOP_COMPMOD_MODULES			! try next record
$    endif
$    goto EOF_COMPMOD				! else: done
$    ! ----------------------------------------
$ERR_COMPMOD:
$    _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$    !! show symbol _STATUS
$    if (_STATUS .eqs. RMS$_RNF)
$    then	! %RMS-E-RNF, record not found
$      goto EOF_COMPMOD		! no module - normal exit
$    endif
$    if (_STATUS .eqs. RMS$_FLK)
$    then	! %RMS-E-FLK, file currently locked by another user
$      wait 00:00:00.05
$      goto LOOP_COMPMOD_MODULES	! retry
$    endif
$    if (_STATUS .eqs. RMS$_RLK)
$    then	! %RMS-E-RLK, target record currently locked by another stream
$      wait 00:00:00.05
$      goto LOOP_COMPMOD_MODULES	! retry
$    endif
$    ! -- some other error - try to unlock current record
$    read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_OLBNAM' /end= EOF_COMPMOD -
	/error= ERR_COMPMOD_IGNORE  FIL_CFGMOD  T_RECORD
$ERR_COMPMOD_IGNORE:
$    set DEFAULT '_DEFAULT'
$    exit _STATUS			! signal error
$! ----------------------------------------
$EOF_COMPMOD:
$   !! show symbol L_COMPMOD_COUNTER
$   BLDRUN_GL_COMPMOD_COUNTER == L_COMPMOD_COUNTER
$   ! reminder: if compilation of all modules-
$   !	put a "@" in front of T_OLBNAM and tell T_PROC to create a new one
$ endif
$! --------------------
$PROC_EXIT:
$ close /noLOG FIL_CFGMOD
$ if (P2 .eqs. "*")
$ then
$   write SYS$ERROR "%BLDRUN-I-DONE, completed: ", P1
$ endif
$ set DEFAULT '_DEFAULT'
$ exit 1
$! ----------------------------------------------------------------------------
$EOF_MODULE:
$ _STATUS = $STATUS
$ write sys$output "EOF_MODULE,",_STATUS
$ goto PROC_EXIT
$ERR_MODULE:
$ _STATUS = $STATUS
$ if (_STATUS .eqs. "%X100182B2") .or. (_STATUS .eqs. "%X000182B2")
$ then		! %RMS-E-RNF, record not found
$     write SYS$ERROR "%BLDRUN-E-NOSUCHMOD, no such module in OLB: ", T_OLBNAM
$     write SYS$ERROR " \", T_MODULE, "\"
$     close /noLOG FIL_CFGMOD
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$ endif
$ write sys$output "ERR_MODULE,",_STATUS
$ close /noLOG FIL_CFGMOD
$ goto PROC_EXIT
$! ----------------------------------------------------------------------------

$! --- end of main program ---
$! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

@@@@
$! ============================================================================
$COUNT_COMPONENT_MODULES: SUBROUTINE
$!++
$! Parameters
$!	P1 = T_COMPONENT
$! Returns:
$!	BLDRUN_GL_MODULE_COUNT
$!--
$ L_MODULE_COUNT = 0
$ T_KEY = F$FAO("!39AS",P1)
$ read /key= &T_KEY /index= 'CFGMOD_K_IDX_COMPONENT' /end= EOF_CFGCMPMODCNT -
	/error= ERR_CFGCMPMODCNT  FIL_CFGMOD  T_RECORD
$ L_MODULE_COUNT = L_MODULE_COUNT + 1		! first record matches
$!
$! -- turn to sequential read
$LOOP_CFGCMPMODCNT:
$ read /end= EOF_CFGCMPMODCNT  FIL_CFGMOD  T_RECORD
$ T_COMPONENT = F$ELEMENT (CFGMOD_K_COMPONENT,"|",T_RECORD)
$!! show symbol t_*
$ if (T_COMPONENT .eqs. T_KEY)
$ then
$   L_MODULE_COUNT = L_MODULE_COUNT + 1		! record matches
$   goto LOOP_CFGCMPMODCNT			! try next record
$ endif
$ goto EOF_CFGCMPMODCNT				! else: done
$! ----------------------------------------
$ERR_CFGCMPMODCNT:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   goto EOF_CFGCMPMODCNT	! no module - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_CFGCMPMODCNT	! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_CFGCMPMODCNT	! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_COMPONENT' /end= EOF_CFGCMPMODCNT -
	/error= ERR_CFGCMPMODCNT_IGNORE  FIL_CFGMOD  T_RECORD
$ERR_CFGCMPMODCNT_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_CFGCMPMODCNT:
$!! show symbol L_MODULE_COUNT
$ BLDRUN_GL_MODULE_COUNT == L_MODULE_COUNT
$ exit 1
$ ENDSUBROUTINE ! $COUNT_COMPONENT_MODULES:
$! ============================================================================

$! ============================================================================
$LIST_COMPONENTS: SUBROUTINE
$!++
$! Returns:
$!	BLDRUN_GL_MODULE_COUNT
$!--
$ L_MODULE_COUNT = 0
$ P1 = " "
$ T_COMPONENT_OLD = ""
$ T_KEY = F$FAO("!39AS",P1)
$ read /key= &T_KEY /index= 'CFGMOD_K_IDX_COMPONENT' /end= EOF_CFGCMPLIS -
	/error= ERR_CFGCMPLIS  FIL_CFGMOD  T_RECORD -
		/match=GE
$ L_MODULE_COUNT = L_MODULE_COUNT + 1		! first record matches
$!
$! -- turn to sequential read
$LOOP_CFGCMPLIS:
$ read /end= EOF_CFGCMPLIS  FIL_CFGMOD  T_RECORD
$ T_COMPONENT_NOW = F$ELEMENT (CFGMOD_K_COMPONENT,"|",T_RECORD)
$!! show symbol t_*
$ if (T_COMPONENT_NOW .nes. T_COMPONENT_OLD)
$ then
$   if (T_COMPONENT_OLD .eqs. "")
$   then
$	write SYS$ERROR "%BLDRUN-I-CMPLIS, listing component names..."
$   endif
$   write SYS$ERROR "    ", T_COMPONENT_NOW
$   T_COMPONENT_OLD = T_COMPONENT_NOW
$   L_MODULE_COUNT = L_MODULE_COUNT + 1		! record matches
$ endif
$ goto LOOP_CFGCMPLIS			! try next record
$! ----------------------------------------
$ERR_CFGCMPLIS:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   goto EOF_CFGCMPLIS	! no module - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_CFGCMPLIS	! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_CFGCMPLIS	! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_COMPONENT' /end= EOF_CFGCMPLIS -
	/error= ERR_CFGCMPLIS_IGNORE  FIL_CFGMOD  T_RECORD
$ERR_CFGCMPLIS_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_CFGCMPLIS:
$!! show symbol L_MODULE_COUNT
$ BLDRUN_GL_MODULE_COUNT == L_MODULE_COUNT
$ exit 1
$ ENDSUBROUTINE ! $LIST_COMPONENTS:
$! ============================================================================

@@@@
$! ============================================================================
$COUNT_OLBNAM_MODULES: SUBROUTINE
$!++
$! Parameters
$!	P1 = T_OLBNAME
$! Returns:
$!	BLDRUN_GL_MODULE_COUNT
$!--
$ L_MODULE_COUNT = 0
$ T_KEY = F$FAO("!39AS",P1)
$ read /key= &T_KEY /index= 'CFGMOD_K_IDX_OLBNAM' /end= EOF_CFGOLBMODCNT -
	/error= ERR_CFGOLBMODCNT  FIL_CFGMOD  T_RECORD
$ L_MODULE_COUNT = L_MODULE_COUNT + 1		! first record matches
$!
$! -- turn to sequential read
$LOOP_CFGOLBMODCNT:
$ read /end= EOF_CFGOLBMODCNT  FIL_CFGMOD  T_RECORD
$ T_OLBNAM = F$ELEMENT (CFGMOD_K_OLBNAM,"|",T_RECORD)
$!! show symbol t_*
$ if (T_OLBNAM .eqs. T_KEY)
$ then
$   L_MODULE_COUNT = L_MODULE_COUNT + 1		! record matches
$   goto LOOP_CFGOLBMODCNT			! try next record
$ endif
$ goto EOF_CFGOLBMODCNT				! else: done
$! ----------------------------------------
$ERR_CFGOLBMODCNT:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   goto EOF_CFGOLBMODCNT	! no module - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_CFGOLBMODCNT	! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_CFGOLBMODCNT	! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_OLBNAM' /end= EOF_CFGOLBMODCNT -
	/error= ERR_CFGOLBMODCNT_IGNORE  FIL_CFGMOD  T_RECORD
$ERR_CFGOLBMODCNT_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_CFGOLBMODCNT:
$!! show symbol L_MODULE_COUNT
$ BLDRUN_GL_MODULE_COUNT == L_MODULE_COUNT
$ exit 1
$ ENDSUBROUTINE ! $COUNT_OLBNAM_MODULES:
$! ============================================================================

$! ============================================================================
$FIND_VMSVER: SUBROUTINE
$!++
$! Parameters:
$!	none
$! Returns:
$!	BLDRUN_GW_VMSVER 
$!--
$ close /noLOG FIL_VMSVER
$ open /read /share=write FIL_VMSVER 'T_FILNAM_VMSVER' /error= ERR_VMSVEROPN
$ goto VMSVER_IS_OPEN
$! --------------------
$ERR_VMSVEROPN:
$   _STATUS = $STATUS
$   write SYS$ERROR "%BLDRUN-F-OPENVER, error opening VMS version file"
$   write SYS$ERROR " \",T_FILNAM_VMSVER,"\"
$   close /noLOG FIL_CFGMOD
$   exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$! --------------------
$VMSVER_IS_OPEN:
$! ----------------------------------------------------------------------------
$ W_VMSVER = "0"
$ T_KEY = F$FAO("!8AS",P1)
$LOOP_VMSVER:
$ read /key= &T_KEY /index= 'VMSVER_K_IDX_VER_NAM' /end= EOF_VMSVER -
	/error= ERR_VMSVER  FIL_VMSVER  T_RECORD
$ W_VMSVER = F$EXTRACT(8,5,T_RECORD)
$ goto EOF_VMSVER				! done
$! ----------------------------------------
$ERR_VMSVER:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   goto EOF_VMSVER		! no version information - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_VMSVER		! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_VMSVER		! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 0 /end= EOF_VMSVER -
	/error= ERR_VMSVER_IGNORE  FIL_VMSVER  T_RECORD
$ERR_VMSVER_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_VMSVER:
$ close /noLOG FIL_VMSVER
$!! show symbol W_VMSVER
$ BLDRUN_GW_VMSVER == W_VMSVER
$ exit 1
$ ENDSUBROUTINE ! $FIND_VMSVER:
$! ============================================================================

$! ============================================================================
$COMPILE_MODULE: SUBROUTINE
$!++
$! Parameter:
$!	P1 = record from configuration file
$!	P2 = "VERABORT" / "NOVERABORT"
$!	P3 = "NEWOLB"   - always create a new object library
$!	     "NONEWOLB" - don't create new olb
$!	     "OLBCRE"   - create olb, if it does not exist, yet
$!	P4 = module counter
$! Returns:
$!	BLDRUN_GX_NOCOMPILE
$!	? 
$!--
$ T_OLBNAM  = F$ELEMENT(CFGMOD_K_OLBNAM, "|",P1) ! .OLB filename (VMS,PARSER,...)
$ T_MODULE  = F$ELEMENT(CFGMOD_K_MODULE, "|",P1) ! module (VMS_SYS)
$ T_OLB     = F$ELEMENT(CFGMOD_K_OLB,    "|",P1) ! insert into .OLB (0/1)
$ T_DBG     = F$ELEMENT(CFGMOD_K_DBG,    "|",P1) ! debug flag (A,N,C)
$ T_THREAD  = F$ELEMENT(CFGMOD_K_THREAD, "|",P1) ! thread only (T,-)
$ T_ENVCOMP = F$ELEMENT(CFGMOD_K_ENVCOMP,"|",P1) ! Environment=Compiler
$ T_VER_AD  = F$ELEMENT(CFGMOD_K_VER_AD, "|",P1) ! OpenVMS Alpha vers(06200)DCL
$ T_VER_AP  = F$ELEMENT(CFGMOD_K_VER_AP, "|",P1) ! OpenVMS Alpha vers(06200)PSX
$ T_VER_VD  = F$ELEMENT(CFGMOD_K_VER_VD, "|",P1) ! OpenVMS VAX vers(06100)DCL
$ T_VER_VP  = F$ELEMENT(CFGMOD_K_VER_VP, "|",P1) ! OpenVMS VAX vers(06100)PSX
$ T_PROC    = F$ELEMENT(CFGMOD_K_PROC,   "|",P1) ! procedure (CC_PYTHON)
$ T_INCL    = F$ELEMENT(CFGMOD_K_INCL,   "|",P1) ! /INCLUDE=
$ ! -----
$ T_OLBNAM  = F$EDIT(T_OLBNAM  ,"COLLAPSE,UPCASE")
$ T_MODULE  = F$EDIT(T_MODULE  ,"COLLAPSE,UPCASE")
$ T_OLB     = F$EDIT(T_OLB     ,"COLLAPSE,UPCASE")
$ T_DBG     = F$EDIT(T_DBG     ,"COLLAPSE,UPCASE")
$ T_THREAD  = F$EDIT(T_THREAD  ,"COLLAPSE,UPCASE")
$ T_ENVCOMP = F$EDIT(T_ENVCOMP ,"COLLAPSE,UPCASE")
$   T_ENV  = F$ELEMENT(0,"=",T_ENVCOMP)	! Environment
$   T_COMP = F$ELEMENT(1,"=",T_ENVCOMP)	! Compiler
$ T_VER_AD  = F$EDIT(T_VER_AD  ,"COLLAPSE")	! number only
$ T_VER_AP  = F$EDIT(T_VER_AP  ,"COLLAPSE")	! number only
$ T_VER_VD  = F$EDIT(T_VER_VD  ,"COLLAPSE")	! number only
$ T_VER_VP  = F$EDIT(T_VER_VP  ,"COLLAPSE")	! number only
$ T_PROC    = F$EDIT(T_PROC    ,"COLLAPSE,UPCASE")
$!T_INCL    = !
$ ! -----
$ if (F$GETSYI("CPU") .GT. 127)
$ then
$   T_VERNAM = T_VER_AD	! @@ add POSIX
$ else
$   T_VERNAM = T_VER_VD ! @@ add posix
$ endif
$ ! -----
$ if (T_VERNAM .gt. BLDRUN_W_VMSVER)
$ then
$   ! @@marker if silently ignore and return
$   if (P2 .eqs. "VERABORT")
$   then
$     write SYS$ERROR "%BLDRUN-E-VERTOHIGH, module requires higher VMS version"
$     write SYS$ERROR " \M:",T_MODULE, -
	  "  V:", T_VERNAM, " > ", BLDRUN_W_VMSVER, " (",T_SYI_VMSVER,")\"
$     close /noLOG FIL_CFGMOD
$     exit (SS$_ABORT .or. STS$M_INHIB_MSG)
$   else
$     BLDRUN_GX_NOCOMPILE = 1	! return to outer CALL level
$     exit 1
$   endif
$ endif
$!!@@show symbol T_*
$ set NOON
$!
$ on WARNING then $ goto ERR_OLBFILSPEC
$ @ 'T_PROC' "OLBFILESPEC|''T_OLBNAM'|''L_CC_VERSION'" ! get file specification of .OLB
$ on WARNING then $ continue
$!
$ if (P3 .eqs. "NEWOLB")	! always create a new object library
$ then
$   !! show symbol BLDRUN_GT_OLBFILESPEC
$   call CREATE_OLB "''T_OLBNAM'" "''BLDRUN_GT_OLBFILESPEC'"
$ else
$   if (P3 .eqs. "OLBCRE")	! create olb, if it does not exist, yet
$   then
$	if (F$SEARCH("''BLDRUN_GT_OLBFILESPEC'") .eqs. "")
$	then
$	  !! show symbol BLDRUN_GT_OLBFILESPEC
$	  call CREATE_OLB "''T_OLBNAM'" "''BLDRUN_GT_OLBFILESPEC'"
$	endif
$   endif
$ endif
$!
$ BLDRUN_T_MODULE_COUNTER = P4	! for diagnostic output
$ on WARNING then $ continue
$ @ 'T_PROC'								-
	"COMPILE|''T_OLBNAM'|''L_CC_VERSION'"				-
	"''T_MODULE'"							-
	"''T_OLB'|''T_DBG'|''T_THREAD'|''T_ENVCOMP'|''T_VER_A'|''T_VER_V'" -
	"''T_INCL'"
$!
$ delete /SYMBOL /GLOBAL BLDRUN_GT_OLBFILESPEC
$ BLDRUN_GX_NOCOMPILE == 0	! return to outer CALL level
$ exit 1
$! --------------------
$ERR_OLBFILSPEC:
$ _STATUS = $STATUS
$ close /noLOG FIL_CFGMOD
$ write SYS$ERROR "%BLDRUN-F-OLBNAMERR, error retrieving OLB filespec"
$! write SYS$ERROR "-",F$EXTRACT(1,9999,F$MESSAGE(_STATUS))
$ exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$ ENDSUBROUTINE ! $COMPILE_MODULE:
$! ============================================================================

$! ============================================================================
$CREATE_OLB: SUBROUTINE
$!++
$! Parameter:
$!	P1 = OLB-name
$!	P2 = OLB-filespec
$! Returns:
$!	None
$!--
$ close /noLOG FIL_CFGOLBCRE
$ open /read /share=write FIL_CFGOLBCRE 'T_FILNAM_CFGOLB' /error= ERR_CFGOLBCREOPN
$ goto CFGOLBCRE_IS_OPEN
$! --------------------
$ERR_CFGOLBCREOPN:
$   _STATUS = $STATUS
$   write SYS$ERROR "%BLDRUN-F-OPENOLBCFG, error opening OLB config file"
$   write SYS$ERROR " \",T_FILNAM_CFGOLB,"\"
$   exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$! --------------------
$CFGOLBCRE_IS_OPEN:
$! ----------------------------------------------------------------------------
$ T_KEY = F$FAO("!39AS",P1)
$ read /key= &T_KEY /index= 'CFGOLB_K_IDX_OLBNAM' /end= EOF_CFGOLBCRE -
	/error= ERR_CFGOLBCRE  FIL_CFGOLBCRE  T_RECORD
$!
$! -----
$ T_OLBNAME  = F$ELEMENT(CFGOLB_K_OLBNAME, "|",T_RECORD) ! .OLB name
$ T_OLBNAME  = F$EDIT(T_OLBNAME, "COLLAPSE")
$ L_MODCOUNT = F$ELEMENT(CFGOLB_K_MODCOUNT,"|",T_RECORD) ! number of modules in .OLB
$ L_SIZALPD  = F$ELEMENT(CFGOLB_K_SIZALPD, "|",T_RECORD) ! size on Alpha with /DEBUG
$ L_SIZALPN  = F$ELEMENT(CFGOLB_K_SIZALPN, "|",T_RECORD) ! size on Alpha with /noDEBUG
$ L_SIZVAXD  = F$ELEMENT(CFGOLB_K_SIZVAXD, "|",T_RECORD) ! size on VAX with /DEBUG
$ L_SIZVAXN  = F$ELEMENT(CFGOLB_K_SIZVAXN, "|",T_RECORD) ! size on VAX with /noDEBUG
$! -----
$ if (F$GETSYI("CPU") .GT. 127)
$ then
$   if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   then
$     L_OLBSIZE = L_SIZALPD
$   else
$     L_OLBSIZE = L_SIZALPN
$   endif
$ else
$   if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   then
$     L_OLBSIZE = L_SIZVAXD
$   else
$     L_OLBSIZE = L_SIZVAXN
$   endif
$ endif
$ goto EOF_CFGOLBCRE
$! ----------------------------------------
$ERR_CFGOLBCRE:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   write SYS$ERROR "%BLDRUN-W-NOOLBCFG, missing configuration for OLB: ", T_OLBNAME
$   write SYS$ERROR "%BLDRUN-I-OLBCFGDEF, using some default values"
$   L_MODCOUNT = 5			! some defaults
$   L_OLBSIZE  = 200
$   goto EOF_CFGOLBCRE			! no module - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto CFGOLBCRE_IS_OPEN	! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto CFGOLBCRE_IS_OPEN	! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_OLBCFG' /end= EOF_CFGOLBCRE -
	/error= ERR_CFGOLBCRE_IGNORE  FIL_CFGOLBCRE  T_RECORD
$ERR_CFGOLBCRE_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_CFGOLBCRE:
$ close FIL_CFGOLBCRE
$ write SYS$ERROR "%BLDRUN-I-OLBCRE, creating ", -
	F$PARSE(P2,,,"NAME","SYNTAX_ONLY"), F$PARSE(P2,,,"TYPE","SYNTAX_ONLY")
$ library /CREATE= (MODULES: 'L_MODCOUNT', BLOCKS= 'L_OLBSIZE')	/log 'P2'
$ set PROTECTION=(S:RWED,O:RWED,G:RE,W:RE) 'P2'
$ exit 1
$ ENDSUBROUTINE ! $CREATE_OLB:
$! ============================================================================

$! ============================================================================
$COMPILE_ALL: SUBROUTINE
$!++
$! Parameters:
$!	None
$!--
$ close /noLOG FIL_CFGOLBALL
$ open /read /share=write FIL_CFGOLBALL 'T_FILNAM_CFGOLB' -
	/error= ERR_CFGOLBOPNALL
$ goto CFGOLBALL_IS_OPEN
$! --------------------
$ERR_CFGOLBOPNALL:
$   _STATUS = $STATUS
$   write SYS$ERROR "%BLDRUN-F-OPENOLBCFG, error opening OLB config file"
$   write SYS$ERROR " \",T_FILNAM_CFGOLB,"\"
$   exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$! --------------------
$CFGOLBALL_IS_OPEN:
$! ----------------------------------------------------------------------------
$LOOP_CFGOLBALL:
$ read /end= EOF_CFGOLBALL /error= ERR_CFGOLBALL  FIL_CFGOLBALL  T_RECORD
$!
$! -----
$ T_OLBNAME  = F$ELEMENT(CFGOLB_K_OLBNAME, "|",T_RECORD) ! .OLB name
$ T_OLBNAME  = F$EDIT(T_OLBNAME, "COLLAPSE")
$! -- recursive call
$ _PR = F$ENVIRONMENT("PROCEDURE")
$ _DEV = F$PARSE(_PR,,,"DEVICE")
$ _DIR = F$PARSE(_PR,,,"DIRECTORY")
$ _NAM = F$PARSE(_PR,,,"NAME")
$ _PROC = _DEV + _DIR + _NAM
$ @ '_PROC' "''T_OLBNAME'" "*"
$ goto LOOP_CFGOLBALL
$! ----------------------------------------
$ERR_CFGOLBALL:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$! not test for RMS$_RNF - no indexed lookuo
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_CFGOLBALL		! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_CFGOLBALL		! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 'CFGMOD_K_IDX_OLBCFG' /end= EOF_CFGOLBALL -
	/error= ERR_CFGOLBALL_IGNORE  FIL_CFGOLBALL  T_RECORD
$ERR_CFGOLBALL_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_CFGOLBALL:
$ close FIL_CFGOLBALL
$ write SYS$ERROR "%BLDRUN-I-ALLDONE, all OLBs processed"
$ exit 1
$ ENDSUBROUTINE ! $COMPILE_ALL:
$! ============================================================================

