$!++
$! VMSVER_FIND.COM - 1-MAR-2000 Uwe Zessin
$!
$! Find internal VMS version number for string.
$!
$! Parameter
$!	P1 = vms version string (e.g. "V5.5-2")
$! Returns
$!	VMSVER_GW_VMSVER        (e.g. "05520"
$!--
$! ----------------------------------------------------------------------------
$ RMS$_FLK        = %X0001828A
$ RMS$_RLK        = %X000182AA
$ RMS$_RNF        = %X000182B2
$ SS$_ABORT       = %X2C
$ STS$M_INHIB_MSG = %X10000000
$! -----
$ T_FILNAM_VMSVER = "PYTHON_VMS:VMSDAT_VMSVER.DAT"
$ VMSVER_K_IDX_VER_NAM = 0
$ VMSVER_K_IDX_VMSVER  = 1 ! non-unique !
$! ----------------------------------------------------------------------------
$!+
$! a unique name for the I/O channel
$!-
$ T_CHNNAM = "FIL_VMSVER_''F$GETJPI(0,"PID")'_''F$ENVIRONMENT("DEPTH")'"
$!
$ close /noLOG 'T_CHNNAM'
$ open /read /share=write 'T_CHNNAM' 'T_FILNAM_VMSVER' /error= ERR_VMSVEROPN
$ goto VMSVER_IS_OPEN
$! --------------------
$ERR_VMSVEROPN:
$   _STATUS = $STATUS
$   write SYS$ERROR "%VMSVER_FIND-F-OPENVER, error opening VMS version file"
$   write SYS$ERROR " \",T_FILNAM_VMSVER,"\"
$   exit (_STATUS .and. (.not. STS$M_INHIB_MSG))
$! --------------------
$VMSVER_IS_OPEN:
$! ----------------------------------------------------------------------------
$ W_VMSVER = ""
$ T_KEY = F$FAO("!8AS",P1)
$LOOP_VMSVER:
$ read /key= &T_KEY /index= 'VMSVER_K_IDX_VER_NAM' /end= EOF_VMSVER -
	/error= ERR_VMSVER  'T_CHNNAM'  T_RECORD
$ W_VMSVER = F$EXTRACT(8,5,T_RECORD)
$ goto EOF_VMSVER				! done
$! ----------------------------------------
$ERR_VMSVER:
$ _STATUS = ($STATUS .and. (.not. STS$M_INHIB_MSG))
$!! show symbol _STATUS
$ if (_STATUS .eqs. RMS$_RNF)
$ then		! %RMS-E-RNF, record not found
$   goto EOF_VMSVER		! no version information - normal exit
$ endif
$ if (_STATUS .eqs. RMS$_FLK)
$ then		! %RMS-E-FLK, file currently locked by another user
$   wait 00:00:00.05
$   goto LOOP_VMSVER		! retry
$ endif
$ if (_STATUS .eqs. RMS$_RLK)
$ then		! %RMS-E-RLK, target record currently locked by another stream
$   wait 00:00:00.05
$   goto LOOP_VMSVER		! retry
$ endif
$! -- some other error - try to unlock current record
$ read /key= "$NOEXIST" /index= 0 /end= EOF_VMSVER -
	/error= ERR_VMSVER_IGNORE  'T_CHNNAM'  T_RECORD
$ERR_VMSVER_IGNORE:
$ exit _STATUS			! signal error
$! ----------------------------------------
$EOF_VMSVER:
$ close /noLOG 'T_CHNNAM'
$!! show symbol W_VMSVER
$ VMSVER_GW_VMSVER == W_VMSVER
$ exit 1
