/* VMS__TZSET.C -- set time zone information -- 23-FEB-2000 Uwe Zessin

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS__TZSET

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS__TZSET "20000304"
#endif

/* ------------------------------------------------------------------------- */
#include <string.h>

#include <descrip.h>
#include <lib$routines.h>
#include <lnmdef.h>
#include <ots$routines.h>
#include <ssdef.h>
#include <starlet.h>
#include <str$routines.h>

#include "vmsdef.h"

/* ------------------------------------------------------------------------- */
extern char		* vms_gat_tzname [2];
extern int		  vms_gl_daylight;
extern long		  vms_gl_timezone;

extern long		  vms_gl_dst_offset;

extern long		  vms_gl_tzdiff;

/* ------------------------------------------------------------------------- */
char vms__tzinfo_lnm  [] = "PYTHON_TIMEZONE_INFO";
char vms__tzdiff_lnm  [] = "SYS$TIMEZONE_DIFFERENTIAL";
char vms__lnm_filedev [] = "LNM$FILE_DEV";

void VMS__TZSET (void)
{
	struct dsc$descriptor_s   r_tabnam;

	char			* at_lognam;
	struct dsc$descriptor_s   r_lognam;

	char			  t_lnmstring[256];
	unsigned short		  w_lnmlen;

	struct dsc$descriptor_s   r_lnmstring;

	/* VMS item-list to be passed to SYS$TRNLNM() */
	struct vmsdef_xr_itmlst3  r_itmlst[2];

	unsigned long		  l_status;

	struct dsc$descriptor_s   r_delimiter;
	char			  t_delimiter;
	long			  l_element;
	struct dsc$descriptor_s   r_tz0name;
	struct dsc$descriptor_s   r_tz0offset;
	long			  l_tz0offset;
	struct dsc$descriptor_s   r_tz1name;
	struct dsc$descriptor_s   r_tz1offset;
	long			  l_tz1offset;
	struct dsc$descriptor_s   r_dst_used;
	long			  l_dst_used;
	struct dsc$descriptor_s   r_dst_doy_begin;
	long			  l_dst_doy_begin;
	struct dsc$descriptor_s   r_dst_doy_end;
	long			  l_dst_doy_end;
	struct dsc$descriptor_s   r_dst_doy_tmp;

	struct dsc$descriptor_s   r_tzdiff;
	long			  l_tzdiff;

	/* -------------------- */
	r_tabnam.dsc$w_length  = strlen(vms__lnm_filedev);
	r_tabnam.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_tabnam.dsc$b_class   = DSC$K_CLASS_S;
	r_tabnam.dsc$a_pointer = &vms__lnm_filedev[0];

	/* -------------------- */
	r_lognam.dsc$w_length  = strlen(vms__tzinfo_lnm);
	r_lognam.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_lognam.dsc$b_class   = DSC$K_CLASS_S;
	r_lognam.dsc$a_pointer = &vms__tzinfo_lnm[0];

	/* -------------------- */
	/* Note: this itemlist will be reused later in this code */
	(void) memset (&t_lnmstring[0], '\0', sizeof (t_lnmstring));
	w_lnmlen = 0;

	r_itmlst[0].w_bufsiz              = sizeof (t_lnmstring);
	r_itmlst[0].w_itmcod              = LNM$_STRING;
	r_itmlst[0].itmlst3_a_bufadr      = &t_lnmstring[0];
	r_itmlst[0].itmlst3_aw_retlenaddr = &w_lnmlen;
	r_itmlst[1].w_bufsiz              = 0;	/* terminate itemlist */
	r_itmlst[1].w_itmcod              = 0;	/* " *"
	r_itmlst[1].itmlst3_a_bufadr      = 0;
	r_itmlst[1].itmlst3_aw_retlenaddr = 0;

	/* -------------------- */
	l_status = sys$trnlnm
			(0		/* [attr]   */
			,&r_tabnam	/* tabnam   */
			,&r_lognam	/* lognam   */
			,0		/* [acmode] */
			,&r_itmlst	/* [itmlst] */
			);
/* @@ test status */
	/* -------------------- */
	t_lnmstring[w_lnmlen] = '\0';	
/* printf ("@vms__tzset: t_lnmstring=%s=\n", t_lnmstring); */

	/* -------------------- */
	/* build descriptors for STR$ routines */
	r_lnmstring.dsc$w_length  = w_lnmlen;
	r_lnmstring.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_lnmstring.dsc$b_class   = DSC$K_CLASS_S;
	r_lnmstring.dsc$a_pointer = &t_lnmstring[0];

	t_delimiter = '|';
	r_delimiter.dsc$w_length  = 1;
	r_delimiter.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_delimiter.dsc$b_class   = DSC$K_CLASS_S;
	r_delimiter.dsc$a_pointer = &t_delimiter;

	r_tz0name.dsc$w_length    = 0;
	r_tz0name.dsc$b_dtype     = DSC$K_DTYPE_T;
	r_tz0name.dsc$b_class     = DSC$K_CLASS_D;
	r_tz0name.dsc$a_pointer   = 0;

	r_tz0offset.dsc$w_length  = 0;
	r_tz0offset.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_tz0offset.dsc$b_class   = DSC$K_CLASS_D;
	r_tz0offset.dsc$a_pointer = 0;

	r_tz1name.dsc$w_length    = 0;
	r_tz1name.dsc$b_dtype     = DSC$K_DTYPE_T;
	r_tz1name.dsc$b_class     = DSC$K_CLASS_D;
	r_tz1name.dsc$a_pointer   = 0;

	r_tz1offset.dsc$w_length  = 0;
	r_tz1offset.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_tz1offset.dsc$b_class   = DSC$K_CLASS_D;
	r_tz1offset.dsc$a_pointer = 0;

	r_dst_used.dsc$w_length  = 0;
	r_dst_used.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_dst_used.dsc$b_class   = DSC$K_CLASS_D;
	r_dst_used.dsc$a_pointer = 0;

	r_dst_doy_begin.dsc$w_length  = 0;
	r_dst_doy_begin.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_dst_doy_begin.dsc$b_class   = DSC$K_CLASS_D;
	r_dst_doy_begin.dsc$a_pointer = 0;

	r_dst_doy_end.dsc$w_length  = 0;
	r_dst_doy_end.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_dst_doy_end.dsc$b_class   = DSC$K_CLASS_D;
	r_dst_doy_end.dsc$a_pointer = 0;

	r_dst_doy_tmp.dsc$w_length  = 0;
	r_dst_doy_tmp.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_dst_doy_tmp.dsc$b_class   = DSC$K_CLASS_D;
	r_dst_doy_tmp.dsc$a_pointer = 0;

	/* -------------------- */
	/* set timezone names only the first time */
	if (vms_gat_tzname[0] == NULL)
	{
	    l_element = 0;		/* get non-DST TZ name */
	    l_status = str$element
		(&r_tz0name		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
	    vms_gat_tzname[0] = r_tz0name.dsc$a_pointer;
/* printf ("@vms__tzset: vms_gat_tzname[0]=%s=\n", vms_gat_tzname[0]); */
	}
	/* ----- */
	l_element = 1;			/* get non-DST TZ offset */
	l_status = str$element
		(&r_tz0offset		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
	/* ----- */
	l_status = ots$cvt_ti_l
		(&r_tz0offset		/* fixed-or-dynamic-input-string */
		,&l_tz0offset		/* varying-output-value          */
		,4			/* [output-value-size]           */
		,0			/* [flags-value]                 */
		);
	vms_gl_timezone = l_tz0offset;
/* printf ("@vms__tzset: vms_gl_daylight=%d=\n", vms_gl_daylight); */

	/* -------------------- */
	/* set timezone names only the first time */
	if (vms_gat_tzname[1] == NULL)
	{
	    l_element = 2;		/* get DST TZ name */
	    l_status = str$element
		(&r_tz1name		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
	    vms_gat_tzname[1] = r_tz1name.dsc$a_pointer;
/* printf ("@vms__tzset: vms_gat_tzname[1]=%s=\n", vms_gat_tzname[1]); */
	}
	/* ----- */
	l_element = 3;			/* get DST TZ offset */
	l_status = str$element
		(&r_tz1offset		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
/* printf ("@l_status-e3:%d\n", l_status); */
	/* ----- */
	l_status = ots$cvt_ti_l
		(&r_tz1offset		/* fixed-or-dynamic-input-string */
		,&l_tz1offset		/* varying-output-value          */
		,4			/* [output-value-size]           */
		,0			/* [flags-value]                 */
		);
/* printf ("@l_status-e3:%d\n", l_status); */
	vms_gl_dst_offset = l_tz1offset;
	/* -------------------- */
	l_element = 4;			/* system is in an area that uses DST */
	l_status = str$element
		(&r_dst_used		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
/* printf ("@l_status-e4:%d\n", l_status); */
	/* ----- */
	l_status = ots$cvt_ti_l
		(&r_dst_used	/* fixed-or-dynamic-input-string */
		,&l_dst_used	/* varying-output-value          */
		,4		/* [output-value-size]           */
		,0		/* [flags-value]                 */
		);
/* printf ("@l_status-e4:%d\n", l_status); */
	if (l_dst_used != 0)
	{
	    l_dst_used = 1;
	}
	vms_gl_daylight = l_dst_used;

/* printf ("@vms__tzset: vms_gl_daylight=%d=\n", vms_gl_daylight); */

	/* -------------------- */
	l_element = 5;			/* day-of-year when DST begins */
	l_status = str$element
		(&r_dst_doy_begin	/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
	/* ----- */
	/* get day of year */
		l_element   = 0;	/* doy */
		t_delimiter = '=';

		l_status = str$element
			(&r_dst_doy_tmp		/* destination-string */
			,&l_element		/* element-number     */
			,&r_delimiter		/* delimiter-string   */
			,&r_dst_doy_begin	/* source-string      */
			);
		l_status = ots$cvt_ti_l
			(&r_dst_doy_tmp	  /* fixed-or-dynamic-input-string */
			,&l_dst_doy_begin /* varying-output-value          */
			,4		  /* [output-value-size]           */
			,0		  /* [flags-value]                 */
			);
	/* @@ extract start time */
		l_status = lib$sfree1_dd (&r_dst_doy_tmp);

	t_delimiter = '|';

	/* -------------------- */
	l_element = 6;			/* day-of-year when DST ends */
	l_status = str$element
		(&r_dst_doy_end		/* destination-string */
		,&l_element		/* element-number     */
		,&r_delimiter		/* delimiter-string   */
		,&r_lnmstring		/* source-string      */
		);
	/* ----- */
	/* get day of year */
		l_element   = 0;	/* doy */
		t_delimiter = '=';

		l_status = str$element
			(&r_dst_doy_tmp		/* destination-string */
			,&l_element		/* element-number     */
			,&r_delimiter		/* delimiter-string   */
			,&r_dst_doy_end		/* source-string      */
			);
		l_status = ots$cvt_ti_l
			(&r_dst_doy_tmp	/* fixed-or-dynamic-input-string */
			,&l_dst_doy_end /* varying-output-value          */
			,4		/* [output-value-size]           */
			,0		/* [flags-value]                 */
			);

	/* @@ extract end time */
		l_status = lib$sfree1_dd (&r_dst_doy_tmp);

	t_delimiter = '|';
	/* -------------------- */

	/* -------------------- */
/* lib$put_output (&r_tz0name       ); */
/* lib$put_output (&r_tz0offset     ); */
/* lib$put_output (&r_tz1name       ); */
/* lib$put_output (&r_tz1offset     ); */
/* lib$put_output (&r_dst_used      ); */
/* lib$put_output (&r_dst_doy_begin ); */
/* lib$put_output (&r_dst_doy_end   ); */

	/* -------------------- */
	/* translate logical name "SYS$TIMEZONE_DIFFERENTIAL" */
	r_tzdiff.dsc$w_length    = strlen (vms__tzdiff_lnm);
	r_tzdiff.dsc$b_dtype     = DSC$K_DTYPE_T;
	r_tzdiff.dsc$b_class     = DSC$K_CLASS_S;
	r_tzdiff.dsc$a_pointer   = &vms__tzdiff_lnm[0];

	/* -------------------- */
	/* reusing itemlist */
	(void) memset (&t_lnmstring[0], '\0', sizeof (t_lnmstring));
	w_lnmlen = 0;

	r_itmlst[0].w_bufsiz              = sizeof (t_lnmstring);
	r_itmlst[0].w_itmcod              = LNM$_STRING;
	r_itmlst[0].itmlst3_a_bufadr      = &t_lnmstring[0];
	r_itmlst[0].itmlst3_aw_retlenaddr = &w_lnmlen;
	/* termination still intact */

	/* -------------------- */
	l_status = sys$trnlnm
			(0		/* [attr]   */
			,&r_tabnam	/* tabnam   */
			,&r_tzdiff	/* lognam   */
			,0		/* [acmode] */
			,&r_itmlst	/* [itmlst] */
			);
/* @@ test status */
	/* -------------------- */
	/* re-use descriptor, now for LNM contents */
	r_tzdiff.dsc$w_length  = w_lnmlen;
	r_tzdiff.dsc$a_pointer = &t_lnmstring[0];

/* lib$put_output (&r_tzdiff); */

	/* ----- */
	l_status = ots$cvt_ti_l
		(&r_tzdiff	/* fixed-or-dynamic-input-string */
		,&l_tzdiff	/* varying-output-value          */
		,4		/* [output-value-size]           */
		,0		/* [flags-value]                 */
		);
/* printf ("@l_status-td:%d\n", l_status); */
	vms_gl_tzdiff = l_tzdiff;
	/* -------------------- */
/* printf ("@vms__tzset: vms_gl_tzdiff=%d=\n", vms_gl_tzdiff); */


} /* void vms__tzset (void) */

/* ------------------------------------------------------------------------- */

/* EOF: VMS__TZSET.C */
