/* VMS_LBR.C -- 07-JAN-1998 Uwe Zessin

   interface to (some) OpenVMS LBR$ routines

28-OCT-1998 ZE. -- cleanups, fix wrong if and bad descriptor setup
26-DEC-1998 ZE. -- fix memory leaks Py_INC/XDECREF(Python function objects)
22-SEP-1999 ZE. -- vms_lbr_methods[] is now configured via data file
		      VMS_LBR__METHODS.DAT - see 'General Manual', configuration
		-- move vms_lbr_output_help to file VMS_LBR_OUTPUT_HELP.C
*/

#ifdef __DECC
#pragma module VMS_LBR "19990922"
#endif

/* ---------------------------------------- */

#include "python.h"
/* includes also: <string.h>, <errno.h> */

/* ------------------------------------------------------------------------- */
PyObject *vms_lbr_gr_error;		/* exception vms_lbr.error */

static char vms_lbr__doc__ [] =
"This is an interface to some OpenVMS LBR$ routines.\n\
See the VMS_LBR documentation for details.";

static char vms_lbr_t_cant_init [] =
"can't initialize module vms_lbr";

static char vms_lbr_t_cant_deferr [] =
"can't define vms_lbr.error";

/* ------------------------------------------------------------------------- */

/* static struct PyMethodDef vms_lbr_methods[] = {
--	{NULL,		NULL}
-- }; */

/* data is now in file 'VMS_LBR__METHODS.DAT' */
/* see 'General Manual', configuration guidelines */
extern struct PyMethodDef vms_lbr__methods[];

/* ---------------------------------------- */

void
initvms_lbr()
{
	PyObject *m, *d, *l, *s, *v;

	m = Py_InitModule4("vms_lbr",
			   vms_lbr__methods,
			   vms_lbr__doc__,
			   (PyObject *)NULL,
			   PYTHON_API_VERSION);
        d = PyModule_GetDict(m);

	/* -------------------- */
        if (PyErr_Occurred())
	{
	    (void) Py_FatalError(vms_lbr_t_cant_init);
	}

	/* -------------------- */
	/* Initialize exception */
	vms_lbr_gr_error = PyErr_NewException("vms_lbr.error", NULL, NULL);
	if (vms_lbr_gr_error == NULL)
	{
	    (void) Py_FatalError(vms_lbr_t_cant_deferr);
	}

	if (PyDict_SetItemString(d, "error", vms_lbr_gr_error) != 0)
	{
	    (void) Py_FatalError(vms_lbr_t_cant_deferr);
	}
} /* initvms_lbr() */

/* ------------------------------------------------------------------------ */

/* EOF: VMS_LBR.C */
