/* VMS_QUIDEF.C -- 05-OCT-1996 Uwe Zessin

   11-SEP-1997 ZE. -- new item-list + bit-mask format
   16-OCT-1997 ZE. -- Rename field 'w_vmsver' to 'w_vmsvermin' and add field
			'w_vmsvermax' because some data can change from
			version to version.
   29-NOV-1997 ZE. -- changes for Python V1.5B1
   11-OCT-1998 ZE. -- load constants and bitmasks via VMSDEF_GR_CB_$QUIDEF[]
   15-FEB-1999 ZE. -- common routine for dictionary insert
*/

/* ---------------------------------------- */

#include "python.h"

#include "vmsdef.h"

/* ------------------------------------------------------------------------- */
/* constants and bitmasks of $QUIDEF */
extern struct vmsdef_xr_conmsktbl VMSDEF_GR_CB_$QUIDEF[];

/* ------------------------------ */
extern int vms__ins_cb_2dict
	(struct vmsdef_xr_conmsktbl * vmsdef_ar_cb_def
	,PyObject		    * ar_dict
	);

/* ------------------------------------------------------------------------- */
static char vms_quidef_doc__ [] = "$QUIDEF";

/* ------------------------------------------------------------------------- */
static struct PyMethodDef vms_quidef_methods[] = {
	{NULL,			NULL}
};

void
initvms_quidef()
{
	PyObject *m, *d, *x;

	m = Py_InitModule4("vms_quidef",
			   vms_quidef_methods,
			   vms_quidef_doc__,
			   (PyObject *)NULL,
			   PYTHON_API_VERSION);
	d = PyModule_GetDict(m);

	/* ----- ----- ----- ----- */
	/* loop through table (in VMSDEF_$QUIDEF.MAR) of constants and */
	/* bitmasks and load them into module 'vms_quidef' */
	if (
	    (vms__ins_cb_2dict (VMSDEF_GR_CB_$QUIDEF, d) < 0) ||
	    (PyErr_Occurred()				    )
	   )
	{
	    Py_FatalError("can't initialize module vms_quidef");
	}
	/* ----- ----- ----- ----- */

} /* initvms_quidef () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_QUIDEF.C */
