/* VMS_SMG_BEGIN_DISPLAY_UPDATE.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$BEGIN_DISPLAY_UPDATE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_BEGIN_DISPLAY_UPDATE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_BEGIN_DISPLAY_UPDATE "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_begin_display_upd__doc[] =
"status = vms_smg.begin_display_update (display_id)\n\
Begin Batching of Display Updates.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_begin_display_update (PyObject *self, PyObject *args)
{
	unsigned long	l_display_id;
	unsigned long	l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "l"
	    ,&l_display_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$begin_display_update (&l_display_id);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_BATWAS_ON))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_begin_display_update () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_BEGIN_DISPLAY_UPDATE.C */
