/* VMS_SMG_CHANGE_RENDITION.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CHANGE_RENDITION

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CHANGE_RENDITION

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CHANGE_RENDITION "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_change_rendition__doc[] =
"status = vms_smg.change_rendition (display_id, start_row, start_column,\
 number_of_rows, number_of_columns, [rendition_set], [rendition_complement])\n\
 Change Default Rendition.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_change_rendition (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_start_row;
	long			  l_start_column;
	long			  l_number_of_rows;
	long			  l_number_of_columns;

	PyObject		* ar_rendition_set;
	unsigned long		  l_rendition_set;
	unsigned long		* al_rendition_set;

	PyObject		* ar_rendition_complement;
	unsigned long		  l_rendition_complement;
	unsigned long		* al_rendition_complement;

	unsigned long		  l_status;

	/* -------------------- */
	ar_rendition_set        = Py_None;
	ar_rendition_complement = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiiii|OO"
	    ,&l_display_id
	    ,&l_start_row
	    ,&l_start_column
	    ,&l_number_of_rows
	    ,&l_number_of_columns
	    ,&ar_rendition_set
	    ,&ar_rendition_complement
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */
	/* -------------------- */
	/* argument 2: start_row */
	/* -------------------- */
	/* argument 3: start_column */
	/* -------------------- */
	/* argument 4: number_of_rows */
	/* -------------------- */
	/* argument 5: number_of_columns */

	/* -------------------- */
	/* argument 6: [rendition_set] */
	if (ar_rendition_set == Py_None)
	{
	    al_rendition_set = 0;		/* omitted */
	    l_rendition_set  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_set))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 6: rendition_set - must be integer or None");
		return NULL;
	    }
	    l_rendition_set = PyInt_AsLong(ar_rendition_set);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_set = &l_rendition_set;
	}

	/* -------------------- */
	/* argument 7: [rendition_complement] */
	if (ar_rendition_complement == Py_None)
	{
	    al_rendition_complement = 0;		/* omitted */
	    l_rendition_complement  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_complement))
	    {
		PyErr_SetString(PyExc_TypeError,
		 "argument 7: rendition_complement - must be integer or None");
		return NULL;
	    }
	    l_rendition_complement = PyInt_AsLong(ar_rendition_complement);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_complement = &l_rendition_complement;
	}

	/* -------------------- */
	l_status = smg$change_rendition
		(&l_display_id
		,&l_start_row
		,&l_start_column
		,&l_number_of_rows
		,&l_number_of_columns
		,al_rendition_set
		,al_rendition_complement
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_NO_CHADIS))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_change_rendition () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CHANGE_RENDITION.C */
