/* VMS_SMG_CREATE_VIEWPORT.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CREATE_VIEWPORT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CREATE_VIEWPORT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CREATE_VIEWPORT "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_create_viewport__doc[] =
"status = vms_smg.create_viewport\
 (display_id, viewport_row_start, viewport_column_start,\
 viewport_number_rows, viewport_number_columns)\n\
Create a Virtual Viewport.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_create_viewport (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_viewport_row_start;
	long			  l_viewport_column_start;

	long			  l_viewport_number_rows;
	long			  l_viewport_number_columns;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiiii"
	    ,&l_display_id
	    ,&l_viewport_row_start
	    ,&l_viewport_column_start
	    ,&l_viewport_number_rows
	    ,&l_viewport_number_columns
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: viewport_row_start */

	/* -------------------- */
	/* argument 3: viewport_column_start */

	/* -------------------- */
	/* argument 4: viewport_number_rows */

	/* -------------------- */
	/* argument 5: viewport_number_columns */

	/* -------------------- */
	l_status = smg$create_viewport
		(&l_display_id
		,&l_viewport_row_start
		,&l_viewport_column_start
		,&l_viewport_number_rows
		,&l_viewport_number_columns
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_WINEXISTS))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_create_viewport () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CREATE_VIEWPORT.C */
