/* VMS_SMG_DELETE_MENU.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_MENU

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_MENU

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_MENU "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_menu__doc[] =
"None = vms_smg.delete_menu (display_id, [flags])\n\
End Access to a Menu in the Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_menu (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_flags;
	long			  l_flags;
	long			* al_flags;

	unsigned long		  l_status;

	/* -------------------- */
	ar_flags = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|O"
	    ,&l_display_id
	    ,&ar_flags
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [flags] */
	if (ar_flags == Py_None)
	{
	    al_flags = 0;		/* omitted */
	    l_flags  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_flags))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: flags - must be integer or None");
		return NULL;
	    }
	    l_flags = PyInt_AsLong(ar_flags);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_flags = &l_flags;
	}

	/* -------------------- */
	l_status = smg$delete_menu (&l_display_id, al_flags);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_menu () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_MENU.C */
