/* VMS_SMG_DELETE_PASTEBOARD.C -- 04-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_PASTEBOARD

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_PASTEBOARD

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_PASTEBOARD "20000304"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_pasteboard__doc[] =
"None = vms_smg.delete_pasteboard (pasteboard_id [,flags])\n\
Delete Pasteboard.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_pasteboard (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	PyObject		* ar_flags;
	unsigned long		  l_flags;
	unsigned long		* al_flags;

	unsigned long		  l_status;

	/* -------------------- */
	ar_flags = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|O"
	    ,&l_pasteboard_id
	    ,&ar_flags
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: l_pasteboard_id */

	/* -------------------- */
	/* argument 2: [flags] */
	if (ar_flags == Py_None)
	{
	    al_flags = 0;		/* omitted */
	    l_flags  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_flags))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: flags - must be integer or None");
		return NULL;
	    }
	    l_flags = PyInt_AsLong(ar_flags);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_flags = &l_flags;
	}

	/* -------------------- */
	l_status = smg$delete_pasteboard
		(&l_pasteboard_id
		,al_flags
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_pasteboard () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_PASTEBOARD.C */
