/* VMS_SMG_END_PASTEBOARD_UPDATE.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$END_PASTEBOARD_UPDATE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_END_PASTEBOARD_UPDATE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_END_PASTEBOARD_UPDATE "20000309"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_end_pbd_update__doc[] =
"status = vms_smg.end_pasteboard_update (pasteboard_id)\n\
End Pasteboard Update.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_end_pasteboard_update (PyObject *self, PyObject *args)
{
	unsigned long	l_pasteboard_id;
	unsigned long	l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "l"
	    ,&l_pasteboard_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$end_pasteboard_update (&l_pasteboard_id);

	/* -------------------- */
	if (
	    (l_status == SS$_NORMAL)     ||
	    (l_status == SMG$_BATWASOFF) ||
	    (l_status == SMG$_BATSTIPRO)
	   )
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_end_pasteboard_update () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_END_PASTEBOARD_UPDATE.C */
