/* VMS_SMG_GET_VIEWPORT_CHAR.C -- 21-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_VIEWPORT_CHAR

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_VIEWPORT_CHAR

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_GET_VIEWPORT_CHAR "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_viewport_char__doc[] =
"viewport_row_start, viewport_column_start,\
 viewport_number_rows, viewport_number_columns\
 = vms_smg.get_viewport_char (display_id)\n\
Get Characteristics of Display Viewport.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_viewport_char (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_viewport_row_start;
	long			  l_viewport_column_start;
	long			  l_viewport_number_rows;
	long			  l_viewport_number_columns;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$get_viewport_char
		(&l_display_id
		,&l_viewport_row_start
		,&l_viewport_column_start
		,&l_viewport_number_rows
		,&l_viewport_number_columns
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("iiii"
		,l_viewport_row_start
		,l_viewport_column_start
		,l_viewport_number_rows
		,l_viewport_number_columns
		);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_get_viewport_char () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_VIEWPORT_CHAR.C */
