/* VMS_SMG_LIST_PASTEBOARD_ORDER.C -- 22-MAR-2000 Uwe Zessin
   Python interface to SMG$LIST_PASTEBOARD_ORDER

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_LIST_PASTEBOARD_ORDER

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_LIST_PASTEBOARD_ORDER "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_list_pbd_order__doc[] =
"status, context, pasteboard_id, pasteboard_row, pasteboard_column\
 = vms_smg.list_pasteboard_order (display_id, context)\n\
Return Pasting Information.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_list_pasteboard_order (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	unsigned long		  l_context;

	unsigned long		  l_pasteboard_id;
	long			  l_pasteboard_row;
	long			  l_pasteboard_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_display_id
	    ,&l_context
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: context */

	/* -------------------- */
	l_status = smg$list_pasteboard_order
		(&l_display_id
		,&l_context
		,&l_pasteboard_id
		,&l_pasteboard_row
		,&l_pasteboard_column
		);

	/* -------------------- */
	/* OpenVMS V6.1 DOC says SMG$_NOPASTED, which is wrong */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_NOTPASTED))
	{
	    return Py_BuildValue ("iiiii"
			,l_status
			,l_context
			,l_pasteboard_id
			,l_pasteboard_row
			,l_pasteboard_column
			);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_list_pasteboard_order () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_LIST_PASTEBOARD_ORDER.C */
