/* VMS_SMG_REPAINT_SCREEN.C -- 26-MAR-2000 Uwe Zessin
   Python interface to SMG$REPAINT_SCREEN

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_REPAINT_SCREEN

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_REPAINT_SCREEN "20000326"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_repaint_screen__doc[] =
"None = vms_smg.repaint_screen (pasteboard_id)\n\
Repaint Current Pasteboard.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_repaint_screen (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	l_status = smg$repaint_screen (&l_pasteboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_repaint_screen () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_REPAINT_SCREEN.C */
