/* VMS_SMG_SET_CURSOR_ABS.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SET_CURSOR_ABS

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SET_CURSOR_ABS

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SET_CURSOR_ABS "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_set_cursor_abs__doc[] =
"None = vms_smg.set_cursor_abs (display_id, [start_row], [start_column])\n\
Set Absolute Cursor Position.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_set_cursor_abs (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_start_row;
	long			  l_start_row;
	long			* al_start_row;

	PyObject		* ar_start_column;
	long			  l_start_column;
	long			* al_start_column;

	unsigned long		  l_status;

	/* -------------------- */
	ar_start_row    = Py_None;
	ar_start_column = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OO"
	    ,&l_display_id
	    ,&ar_start_row
	    ,&ar_start_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [start_row] */
	if (ar_start_row == Py_None)
	{
	    al_start_row = 0;		/* omitted */
	    l_start_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_start_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: start_row - must be integer or None");
		return NULL;
	    }
	    l_start_row = PyInt_AsLong(ar_start_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_start_row = &l_start_row;
	}

	/* -------------------- */
	/* argument 3: [start_column] */
	if (ar_start_column == Py_None)
	{
	    al_start_column = 0;		/* omitted */
	    l_start_column  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_start_column))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: start_column - must be integer or None");
		return NULL;
	    }
	    l_start_column = PyInt_AsLong(ar_start_column);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_start_column = &l_start_column;
	}

	/* -------------------- */
	l_status = smg$set_cursor_abs
		(&l_display_id
		,al_start_row
		,al_start_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_set_cursor_abs () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SET_CURSOR_ABS.C */
