/* VMS_SMG_SNAPSHOT.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SNAPSHOT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SNAPSHOT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SNAPSHOT "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_snapshot__doc[] =
"status = vms_smg.snapshot (display_id, [flags])\n\
Write Snapshot.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_snapshot (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_flags;
	long			  l_flags;
	long			* al_flags;

	unsigned long		  l_status;

	/* -------------------- */
	ar_flags = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|O"
	    ,&l_display_id
	    ,&ar_flags
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [flags] */
	if (ar_flags == Py_None)
	{
	    al_flags = 0;		/* omitted */
	    l_flags  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_flags))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: flags - must be integer or None");
		return NULL;
	    }
	    l_flags = PyInt_AsLong(ar_flags);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_flags = &l_flags;
	}

	/* -------------------- */
	l_status = smg$snapshot
		(&l_display_id
		,al_flags
		);

	/* -------------------- */
	return Py_BuildValue ("i", l_status);
} /* vms_smg_snapshot () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SNAPSHOT.C */
